<?php
require_once(dirname(__FILE__) . '/class.low.u.php');

if (!class_exists('DUP_PRO_ALERT_U'))
{
	class DUP_PRO_ALERT_U
	{
		public static function license_alert_check()
		{
			$on_licensing_tab = (isset($_REQUEST['tab']) && ($_REQUEST['tab'] === 'licensing'));

			if ($on_licensing_tab === false)
			{
				if(!file_exists(DUPLICATOR_PRO_SSDIR_PATH . "/ovr.dup"))
				{
					//Style needs to be loaded here because css is global across wp-admin
					wp_enqueue_style('dup-pro-plugin-style-notices', DUPLICATOR_PRO_PLUGIN_URL . 'assets/css/admin-notices.css', null, DUPLICATOR_PRO_VERSION);
					$license_status = DUP_PRO_License_Utility::get_license_status(false);

					if ($license_status === DUP_PRO_License_Status::Expired)
					{
						self::display_expired_alert();
					}
					else if ($license_status !== DUP_PRO_License_Status::Valid)
					{				
						/* @var $global DUP_PRO_Global_Entity */
						$global = DUP_PRO_Global_Entity::get_instance();

						if ($global->license_no_activations_left)
						{
							self::display_no_activations_left_alert();
						}
						else
						{					
							$days_invalid = floor((time() - $global->initial_activation_timestamp) / 86400);

							// If an md5 is present always do standard nag						
							$license_key = get_option(DUP_PRO_Constants::LICENSE_KEY_OPTION_NAME, '');

							$md5_present = DUP_PRO_Low_U::is_valid_md5($license_key);

							if ($md5_present || ($days_invalid < DUP_PRO_Constants::UNLICENSED_SUPER_NAG_DELAY_IN_DAYS))
							{
								self::display_invalid_standard_nag_alert();
							}
							else
							{
								self::display_invalid_super_nag_alert($days_invalid);
							}
						}
					}
				}
			}
		}
		
		private static function display_expired_alert()
		{
			$license_key = get_option(DUP_PRO_Constants::LICENSE_KEY_OPTION_NAME, '');
			$renewal_url = 'https://snapcreek.com/checkout?edd_license_key=' . $license_key;
			$img_url = plugins_url('duplicator-pro/assets/img/plug.png');

		
		}
		
		private static function display_no_activations_left_alert()
		{
			$licensing_tab_url = self_admin_url() . "admin.php?page=" . DUP_PRO_Constants::$SETTINGS_SUBMENU_SLUG . '&tab=licensing';
			$dashboard_url = 'https://snapcreek.com/dashboard';
			$img_url = plugins_url('duplicator-pro/assets/img/warning.png');

			
		}
		
		private static function display_invalid_standard_nag_alert()
		{
			$img_url = plugins_url('duplicator-pro/assets/img/warning.png');
			$licensing_tab_url = self_admin_url() . "admin.php?page=" . DUP_PRO_Constants::$SETTINGS_SUBMENU_SLUG . '&tab=licensing';
			
			
		}
		
		private static function display_invalid_super_nag_alert($days_invalid)
		{			
			$img_url = plugins_url('duplicator-pro/assets/img/rejected_350.png');
			$licensing_tab_url = self_admin_url() . "admin.php?page=" . DUP_PRO_Constants::$SETTINGS_SUBMENU_SLUG . '&tab=licensing';
			
		
		}
	}
}